#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define SIZE 10 // deve essere almeno 1

// == dichiarazione funzioni ==================================================
void ordina(int[], int);
void riempi(int[], int);
void stampa(int[], int);

// == definizione funzioni ====================================================

int main(void) {
  int a[SIZE];

  riempi(a, SIZE);
  printf("Array originale: ");
  stampa(a, SIZE);
  ordina(a, SIZE);
  printf("Array ordinato:  ");
  stampa(a, SIZE);
}

/* Ordina array.
 * Alla iterazione i:
 * - gli elementi da 0 a i - 1 sono in ordine
 * - l'elemento in posizione i viene inserito nella parte
 *   gia' ordinata scorrendo verso sx
 */
void ordina(int a [], int length) {    
  int i, j, temp;
  
  for (i = 1; i < length; i++)
    for (j = i; j > 0 && a[j] < a[j - 1]; j--) {
      int temp = a[j -1];
      a[j -1] = a[j];
      a[j] = temp;
    }
}

/* Funzione che riempie l'array a di valori casuali compresi tra 0 e 9
 */
void riempi(int a[], int length) {
  int i;
  
  srand (time(NULL));
  for (i = 0; i < length; i++) {
    a[i] = rand() % 10;
  }
}

/* Funzione che stampa gli elementi dell'array a.
 */
void stampa(int a[], int size) {
  int i;
  
  printf("[ ");
  for (i = 0; i < size; i++)
    printf("%i ", a[i]);
  printf(" ]\n");
}
